/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the EverflowControllerActionMetricRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &EverflowControllerActionMetricRequest{}

// EverflowControllerActionMetricRequest struct for EverflowControllerActionMetricRequest
type EverflowControllerActionMetricRequest struct {
	ReportType *string `json:"reportType,omitempty"`
}

// NewEverflowControllerActionMetricRequest instantiates a new EverflowControllerActionMetricRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewEverflowControllerActionMetricRequest() *EverflowControllerActionMetricRequest {
	this := EverflowControllerActionMetricRequest{}
	return &this
}

// NewEverflowControllerActionMetricRequestWithDefaults instantiates a new EverflowControllerActionMetricRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewEverflowControllerActionMetricRequestWithDefaults() *EverflowControllerActionMetricRequest {
	this := EverflowControllerActionMetricRequest{}
	return &this
}

// GetReportType returns the ReportType field value if set, zero value otherwise.
func (o *EverflowControllerActionMetricRequest) GetReportType() string {
	if o == nil || IsNil(o.ReportType) {
		var ret string
		return ret
	}
	return *o.ReportType
}

// GetReportTypeOk returns a tuple with the ReportType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EverflowControllerActionMetricRequest) GetReportTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ReportType) {
		return nil, false
	}
	return o.ReportType, true
}

// HasReportType returns a boolean if a field has been set.
func (o *EverflowControllerActionMetricRequest) HasReportType() bool {
	if o != nil && !IsNil(o.ReportType) {
		return true
	}

	return false
}

// SetReportType gets a reference to the given string and assigns it to the ReportType field.
func (o *EverflowControllerActionMetricRequest) SetReportType(v string) {
	o.ReportType = &v
}

func (o EverflowControllerActionMetricRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o EverflowControllerActionMetricRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ReportType) {
		toSerialize["reportType"] = o.ReportType
	}
	return toSerialize, nil
}

type NullableEverflowControllerActionMetricRequest struct {
	value *EverflowControllerActionMetricRequest
	isSet bool
}

func (v NullableEverflowControllerActionMetricRequest) Get() *EverflowControllerActionMetricRequest {
	return v.value
}

func (v *NullableEverflowControllerActionMetricRequest) Set(val *EverflowControllerActionMetricRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableEverflowControllerActionMetricRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableEverflowControllerActionMetricRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableEverflowControllerActionMetricRequest(val *EverflowControllerActionMetricRequest) *NullableEverflowControllerActionMetricRequest {
	return &NullableEverflowControllerActionMetricRequest{value: val, isSet: true}
}

func (v NullableEverflowControllerActionMetricRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableEverflowControllerActionMetricRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
